% This is just a wrapper to the Naive Bayes Methods of the Matlab Statistics Toolbox 
classdef janis_NaiveBayes < janis_classifier & janis_statisticsWrapper
    
    properties (Constant)
        availableDist = {       'normal', ...
            'kernel', ...
            'mvmn', ...
            'mn'};                              % available Distance Functions
    end
    
    properties (SetAccess = protected)
        nbParams = {'dist','normal'};           % Params to use, default normal distance
    end
    
    methods (Static)
        function shortName = name
            shortName = 'Naive Bayes';
        end
    end

    methods
       
        function jc = train(jc,trainPatterns,trainLabels)
            % train calls the fit function of naive bayes
            jc.classifierStruct = NaiveBayes.fit(trainPatterns',trainLabels,jc.nbParams{:});
        end
        
        function [predictions decFactors] = test(jc,testPatterns)
            % test calls predicit of the struct previously trained
            predictions = jc.classifierStruct.predict(testPatterns');
            % not implemented yet!
            decFactors = struct;
        end
        
        function classifierStruct  = getClassifier(jc,trainPatterns,trainLabels)
            classifierStruct = NaiveBayes.fit(trainPatterns',trainLabels);
        end
        
        function jc = uiconfigure(jc)
            dIdx = listdlg('PromptString','Select Distance Function:','SelectionMode','single','ListString',jc.availableDist);
            jc.nbParams{2} = jc.availableDist{dIdx};
        end
        
        function show(jc)
            show@janis_classifier(jc);
            fprintf('Distance Function:   %s',jc.nbParams{2});
        end
    end
end