classdef janis_ensembleParser < janis_patternParser
    % EnsembleParser does not parse the patterns, but classifiers (which act
    % in an ensemble as a kind of pattern)%
    
    methods
        
        function this = janis_ensembleParser(classCollection)
            % Constructor
            this = this@janis_patternParser(classCollection);
            if ~isa(classCollection,'janis_classCollection')
                throw(MException('janis:WrongClass','This is not a janis_classCollection!'));
            end
        end
        
        function this = init(this)
            % gets all Patterns from all subjects and generates a Matrix
            % which is used to return the a matrix by specified subjects
            
            % I think I will nothing do here and provide instead a function
            % to add new classifiers
            %            % init helper Matrices
            %            % Patternsize: Voxels X Subjects
            this.patternLabels = zeros(this.classCollection.patternCount,1);
            actualIndex = 1;
            %            % go through all classes
            for cl=1:this.classCollection.size
                % for each class
                actualClass = this.classCollection.get(cl);
                this.patternLabels(actualIndex:actualIndex+actualClass.size-1) = cl -1;
                actualIndex = actualIndex + actualClass.size;
            end
            for k=1:size(this.patternMat,2)
                this.patternMat{k}.patternParser.init;
            end
        end
        
        function [trainPattern, trainLabels, testPattern, testLabels] = get(this,indices)
            % get patterns according to indices specified.
            trainPattern = this.patternMat;
            trainLabels = indices;
            testLabels  = ~indices;
            testPattern = testLabels;
        end
        
        function this = addValidatorToEnsemble(this,validatorNode)
            % add new classifier/validator to ensemble.
            if ~isa(validatorNode,'janis_validator')
                throw(MException('janis:WrongClass','This is not a validator-Class!'));
            else
                this.patternMat{size(this.patternMat,2)+1} = validatorNode;
            end
        end
        
        function pattern = reconstructFromProcessors(this,pattern)
            % This is not (and probably will never) be implemented.
            error('This function is not implemented!');
        end
        
        function labelsAll = getLabels(this)
            % returns labels of patterns
            labelsAll = this.patternLabels;
        end
    end
end