% Preprocessor: Feature Selection BEFORE cross validation
classdef janis_preprocessor < janis_patternManipulatorMethod
    
    properties (SetAccess = protected)
        previousOperations = {};    % this will be needed, if there were other preprocessors before, to keep patterns consistent
    end
    
    methods (Static)
        function beVisible = shouldBeVisible
            % if the method should appear in the GUI
            beVisible = true;
        end
    end
    
    methods
        function this = setPreviousOperations(this, operations)
            % set previous operations (needed, if other masks were applied...
            %   For instance: Assume previously were NaNs masks, then the
            %   NaN-mask has to be applied on the roi of this class...
            this.previousOperations = operations;
        end
        
        function new = copy(this)
            % returns a copy of this object
            new = copy@janis_patternManipulatorMethod(this);
            tmp = {};
            for k=1:length(this.previousOperations)
                tmp{length(tmp)+1} = this.previousOperations{k}.copy;
            end
            new.previousOperations = tmp;
        end
        
        function viewSettings(this)
            % view human readable textual representation of the method and
            % its setings
            viewSettings@janis_patternManipulatorMethod(this);
            fprintf('  Type:  %s\n','applied before crossvalidation');
        end
        
    end
    
end