% apply center the voxels of every subject to zero.
%   For each subject: substract mean of the voxel of this subject from all
%   voxels of this subject.
classdef janis_pro_centering < janis_processor
    
   properties
       trainmean;                       % mean of training samples
       testmean;                        % mean of test samples
   end
   
   methods (Static)
       function desc = description
           desc = 'Mean Centering - Centers each voxel using training data to average of zero';
       end
       function shortName = name
           shortName = 'Mean Centering';
       end
   end
    
   methods
       
       function [train, test] = operate(this,train, test,trainLabels)
           % apply centering
            this.trainmean = mean(train');
            tmp = bsxfun(@minus,train',this.trainmean);
            train = tmp';
            tmp = bsxfun(@minus,test',this.trainmean);  
            test = tmp';
       end
       
       function patternRecon  = reconstruct(this,patternIn)
           % Do nothing - not necessary...
            patternRecon  = patternIn;
       end
       
       function patOut = reoperate(this,patternIn)
          error('not implemented'); 
       end
       
   end
   
    
end