% Z-Scoring of patterns
classdef janis_pro_zscoring < janis_processor
    
    properties
        voxelmean;          % mean of voxels
    end
    
    methods (Static)
        function desc = description
            desc = 'Z-Scoring on training data';
        end
        function shortName = name
            shortName = 'Z-Scoring';
        end
    end
    
    methods
        
        function [train, test] = operate(jpz,train, test,trainLabels)
            jpz.voxelmean = mean(train');
            train = (bsxfun(@minus,train',jpz.voxelmean))';
            test = (bsxfun(@minus,test',jpz.voxelmean))';
        end
        
        function patternRecon  = reconstruct(jpz,patternIn)
            % Do nothing - not necessary...
            patternRecon  = patternIn;
        end
        
        function patOut = reoperate(this,patternIn)
            error('not implemented');
        end
        
    end
    
    
end