% evaluatle thresholded map with aal-toolbox
%
function ia_aal(varargin)
[path ignore] = fileparts(which('aal'));
if ~exist(path,'dir')
    warning('Could not find aal Toolbox, please check your matlab path settings');
    path = uigetdir(pwd, 'Specify location of aal directory');
    if exist(path,'dir')
            addpath(path);
    else
        error('Could not add to path');
    end
end

[svmap status] = spm_select(1,'image','Select thresholded discriminative Map');   
[groupIdx,YPos] = spm_input('Which Group to display?','+1','b','First|Second',[-1;1],1);
[threshold,YPos] = spm_input('Threshold? (0 for anything)','+1','r','0');
groupnames = {'First'; 'Second'};
title = ['Thresholded Discriminative Map - ' groupnames{(groupIdx==1)+1} ' Group'];
%load('/spm-data/vault-data2/SuslowDannlowski/b01/SUB_SPM5/SPM.mat');
[spmfile status] = spm_select(1,'SPM.mat','Select appropriate SPM.mat associated with the condition.');
if status
    load(spmfile);
else
    error('Could not load SPM.mat');
end
xCon    = SPM.xCon;
xCon(1).Vspm.fname = svmap(:,1:end-2); 
XYZ     = SPM.xVol.XYZ;
Z       = spm_get_data(xCon(1).Vspm,XYZ);
Q       = find(Z*groupIdx > threshold);
Zneu    = Z(:,Q);
XYZneu  = XYZ(:,Q);
xX      = SPM.xX;
df      = [xCon.eidf xX.erdf];
M       = SPM.xVol.M;  %-voxels to mm matrix
M2      = SPM.xVol.M(1:3,1:3);
VOX     = sqrt(diag(M2'*M2))'; %-voxel dimensions
Z       = Q;
xSPM    = struct('XYZ',     XYZneu, ...
    'XYZmm',                SPM.xVol.M(1:3,:)*[XYZneu; ones(1,size(XYZneu,2))], ...
    'S',                    SPM.xVol.S, ...  
    'R',                    SPM.xVol.R, ...
    'FWHM',                 SPM.xVol.FWHM, ...
    'VOX',                  VOX, ...
    'n',                    1,...
    'STAT',                 'T', ...
    'df',                   df, ...
    'u',                    -Inf, ...
    'M',                    M, ...
    'k',                    0, ...
    'swd',                  xCon(1).Vspm.fname, ...
    'title',                title, ...
    'Z',                    Z);
gin_clusters_plabels('List',xSPM)

